package io.zipcoder;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ItemParser {


    public ArrayList<String> parseRawDataIntoStringArray(String rawData){
        String stringPattern = "##";
        ArrayList<String> response = splitStringWithRegexPattern(stringPattern , rawData);
        return response;
    }

    public Item parseStringIntoItem(String rawItem) throws ItemParseException
    {
        ArrayList<String> values = getValues(toLowerCase(rawItem));

        String name = values.get(0);
        Double price = Double.valueOf(values.get(1));
        String type = values.get(2);
        String expiration = values.get(3);

        return new Item(name,price,type,expiration);

    }
    private String getValue(String input)
    {
        return splitStringWithRegexPattern(":" , input).get(1);
    }

    private ArrayList<String> getValues(String rawItem) throws ItemParseException {
        ArrayList<String> KVPairs = findKeyValuePairsInRawItemData(rawItem);
        ArrayList<String> values = new ArrayList<String>();
        for(String pair : KVPairs)
        {
            String value = getValue(pair);
            if(value .equals(""))
            {
                throw  new ItemParseException();
            }
            else
            {
                values.add(value);
            }
        }
        return values;
    }

    public ArrayList<String> findKeyValuePairsInRawItemData(String rawItem){
        String stringPattern = "[^a-zA-Z0-9\\:\\.\\/]";
        ArrayList<String> response = splitStringWithRegexPattern(stringPattern , rawItem);
        return response;
    }

    private ArrayList<String> splitStringWithRegexPattern(String stringPattern, String inputString){
        return new ArrayList<String>(Arrays.asList(inputString.split(stringPattern)));
    }

    public String toLowerCase(String test)
    {
        String[] lower = {"a","b","c","d","e","f","g","h","i","j","k","l","m","o","q","s","u","v","w","x","y","z"};
        String[] upper = {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"};

        StringBuilder lowercase = new StringBuilder();

            Pattern pattern =Pattern.compile(".");
            Matcher matcher = pattern.matcher(test);


            while(matcher.find())
            {
                String character = matcher.group();
                if(isUpper(character))
                {
                    int i = indexOf(upper,character);
                            lowercase.append(lower[i]);
                }else {
                    lowercase.append(character);
                }
            }
            return lowercase.toString();
    }

    public boolean isUpper(String c)
    {
        Pattern pattern = Pattern.compile("[A-Z]");
        Matcher matcher = pattern.matcher(c);
        return matcher.find();
    }
    public int indexOf(String[] array,String c)
    {
        for(int i =0; i<array.length;i++)
        {
            if(array[i].equals(c))
            {
                return i;
            }
        }
        return -1;
    }

}
